/*
Copyright 2022 SUSE LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

// +k8s:deepcopy-gen=package
// +groupName=elemental.cattle.io
package v1beta1

import (
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object

// MachineInventoryList is a list of MachineInventory resources
type MachineInventoryList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata"`

	Items []MachineInventory `json:"items"`
}

func NewMachineInventory(namespace, name string, obj MachineInventory) *MachineInventory {
	obj.APIVersion, obj.Kind = SchemeGroupVersion.WithKind("MachineInventory").ToAPIVersionAndKind()
	obj.Name = name
	obj.Namespace = namespace
	return &obj
}

// +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object

// MachineInventorySelectorList is a list of MachineInventorySelector resources
type MachineInventorySelectorList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata"`

	Items []MachineInventorySelector `json:"items"`
}

func NewMachineInventorySelector(namespace, name string, obj MachineInventorySelector) *MachineInventorySelector {
	obj.APIVersion, obj.Kind = SchemeGroupVersion.WithKind("MachineInventorySelector").ToAPIVersionAndKind()
	obj.Name = name
	obj.Namespace = namespace
	return &obj
}

// +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object

// MachineInventorySelectorTemplateList is a list of MachineInventorySelectorTemplate resources
type MachineInventorySelectorTemplateList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata"`

	Items []MachineInventorySelectorTemplate `json:"items"`
}

func NewMachineInventorySelectorTemplate(namespace, name string, obj MachineInventorySelectorTemplate) *MachineInventorySelectorTemplate {
	obj.APIVersion, obj.Kind = SchemeGroupVersion.WithKind("MachineInventorySelectorTemplate").ToAPIVersionAndKind()
	obj.Name = name
	obj.Namespace = namespace
	return &obj
}

// +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object

// MachineRegistrationList is a list of MachineRegistration resources
type MachineRegistrationList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata"`

	Items []MachineRegistration `json:"items"`
}

func NewMachineRegistration(namespace, name string, obj MachineRegistration) *MachineRegistration {
	obj.APIVersion, obj.Kind = SchemeGroupVersion.WithKind("MachineRegistration").ToAPIVersionAndKind()
	obj.Name = name
	obj.Namespace = namespace
	return &obj
}

// +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object

// ManagedOSImageList is a list of ManagedOSImage resources
type ManagedOSImageList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata"`

	Items []ManagedOSImage `json:"items"`
}

func NewManagedOSImage(namespace, name string, obj ManagedOSImage) *ManagedOSImage {
	obj.APIVersion, obj.Kind = SchemeGroupVersion.WithKind("ManagedOSImage").ToAPIVersionAndKind()
	obj.Name = name
	obj.Namespace = namespace
	return &obj
}

// +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object

// ManagedOSVersionList is a list of ManagedOSVersion resources
type ManagedOSVersionList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata"`

	Items []ManagedOSVersion `json:"items"`
}

func NewManagedOSVersion(namespace, name string, obj ManagedOSVersion) *ManagedOSVersion {
	obj.APIVersion, obj.Kind = SchemeGroupVersion.WithKind("ManagedOSVersion").ToAPIVersionAndKind()
	obj.Name = name
	obj.Namespace = namespace
	return &obj
}

// +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object

// ManagedOSVersionChannelList is a list of ManagedOSVersionChannel resources
type ManagedOSVersionChannelList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata"`

	Items []ManagedOSVersionChannel `json:"items"`
}

func NewManagedOSVersionChannel(namespace, name string, obj ManagedOSVersionChannel) *ManagedOSVersionChannel {
	obj.APIVersion, obj.Kind = SchemeGroupVersion.WithKind("ManagedOSVersionChannel").ToAPIVersionAndKind()
	obj.Name = name
	obj.Namespace = namespace
	return &obj
}
