/*
Copyright 2022 SUSE LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/rancher/elemental-operator/pkg/apis/elemental.cattle.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMachineInventories implements MachineInventoryInterface
type FakeMachineInventories struct {
	Fake *FakeElementalV1beta1
	ns   string
}

var machineinventoriesResource = schema.GroupVersionResource{Group: "elemental.cattle.io", Version: "v1beta1", Resource: "machineinventories"}

var machineinventoriesKind = schema.GroupVersionKind{Group: "elemental.cattle.io", Version: "v1beta1", Kind: "MachineInventory"}

// Get takes name of the machineInventory, and returns the corresponding machineInventory object, and an error if there is any.
func (c *FakeMachineInventories) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.MachineInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(machineinventoriesResource, c.ns, name), &v1beta1.MachineInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventory), err
}

// List takes label and field selectors, and returns the list of MachineInventories that match those selectors.
func (c *FakeMachineInventories) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.MachineInventoryList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(machineinventoriesResource, machineinventoriesKind, c.ns, opts), &v1beta1.MachineInventoryList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.MachineInventoryList{ListMeta: obj.(*v1beta1.MachineInventoryList).ListMeta}
	for _, item := range obj.(*v1beta1.MachineInventoryList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested machineInventories.
func (c *FakeMachineInventories) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(machineinventoriesResource, c.ns, opts))

}

// Create takes the representation of a machineInventory and creates it.  Returns the server's representation of the machineInventory, and an error, if there is any.
func (c *FakeMachineInventories) Create(ctx context.Context, machineInventory *v1beta1.MachineInventory, opts v1.CreateOptions) (result *v1beta1.MachineInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(machineinventoriesResource, c.ns, machineInventory), &v1beta1.MachineInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventory), err
}

// Update takes the representation of a machineInventory and updates it. Returns the server's representation of the machineInventory, and an error, if there is any.
func (c *FakeMachineInventories) Update(ctx context.Context, machineInventory *v1beta1.MachineInventory, opts v1.UpdateOptions) (result *v1beta1.MachineInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(machineinventoriesResource, c.ns, machineInventory), &v1beta1.MachineInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventory), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeMachineInventories) UpdateStatus(ctx context.Context, machineInventory *v1beta1.MachineInventory, opts v1.UpdateOptions) (*v1beta1.MachineInventory, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(machineinventoriesResource, "status", c.ns, machineInventory), &v1beta1.MachineInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventory), err
}

// Delete takes name of the machineInventory and deletes it. Returns an error if one occurs.
func (c *FakeMachineInventories) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(machineinventoriesResource, c.ns, name), &v1beta1.MachineInventory{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMachineInventories) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(machineinventoriesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.MachineInventoryList{})
	return err
}

// Patch applies the patch and returns the patched machineInventory.
func (c *FakeMachineInventories) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.MachineInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(machineinventoriesResource, c.ns, name, pt, data, subresources...), &v1beta1.MachineInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventory), err
}
