/*
Copyright 2022 SUSE LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/rancher/elemental-operator/pkg/apis/elemental.cattle.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMachineInventorySelectors implements MachineInventorySelectorInterface
type FakeMachineInventorySelectors struct {
	Fake *FakeElementalV1beta1
	ns   string
}

var machineinventoryselectorsResource = schema.GroupVersionResource{Group: "elemental.cattle.io", Version: "v1beta1", Resource: "machineinventoryselectors"}

var machineinventoryselectorsKind = schema.GroupVersionKind{Group: "elemental.cattle.io", Version: "v1beta1", Kind: "MachineInventorySelector"}

// Get takes name of the machineInventorySelector, and returns the corresponding machineInventorySelector object, and an error if there is any.
func (c *FakeMachineInventorySelectors) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.MachineInventorySelector, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(machineinventoryselectorsResource, c.ns, name), &v1beta1.MachineInventorySelector{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelector), err
}

// List takes label and field selectors, and returns the list of MachineInventorySelectors that match those selectors.
func (c *FakeMachineInventorySelectors) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.MachineInventorySelectorList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(machineinventoryselectorsResource, machineinventoryselectorsKind, c.ns, opts), &v1beta1.MachineInventorySelectorList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.MachineInventorySelectorList{ListMeta: obj.(*v1beta1.MachineInventorySelectorList).ListMeta}
	for _, item := range obj.(*v1beta1.MachineInventorySelectorList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested machineInventorySelectors.
func (c *FakeMachineInventorySelectors) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(machineinventoryselectorsResource, c.ns, opts))

}

// Create takes the representation of a machineInventorySelector and creates it.  Returns the server's representation of the machineInventorySelector, and an error, if there is any.
func (c *FakeMachineInventorySelectors) Create(ctx context.Context, machineInventorySelector *v1beta1.MachineInventorySelector, opts v1.CreateOptions) (result *v1beta1.MachineInventorySelector, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(machineinventoryselectorsResource, c.ns, machineInventorySelector), &v1beta1.MachineInventorySelector{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelector), err
}

// Update takes the representation of a machineInventorySelector and updates it. Returns the server's representation of the machineInventorySelector, and an error, if there is any.
func (c *FakeMachineInventorySelectors) Update(ctx context.Context, machineInventorySelector *v1beta1.MachineInventorySelector, opts v1.UpdateOptions) (result *v1beta1.MachineInventorySelector, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(machineinventoryselectorsResource, c.ns, machineInventorySelector), &v1beta1.MachineInventorySelector{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelector), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeMachineInventorySelectors) UpdateStatus(ctx context.Context, machineInventorySelector *v1beta1.MachineInventorySelector, opts v1.UpdateOptions) (*v1beta1.MachineInventorySelector, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(machineinventoryselectorsResource, "status", c.ns, machineInventorySelector), &v1beta1.MachineInventorySelector{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelector), err
}

// Delete takes name of the machineInventorySelector and deletes it. Returns an error if one occurs.
func (c *FakeMachineInventorySelectors) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(machineinventoryselectorsResource, c.ns, name), &v1beta1.MachineInventorySelector{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMachineInventorySelectors) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(machineinventoryselectorsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.MachineInventorySelectorList{})
	return err
}

// Patch applies the patch and returns the patched machineInventorySelector.
func (c *FakeMachineInventorySelectors) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.MachineInventorySelector, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(machineinventoryselectorsResource, c.ns, name, pt, data, subresources...), &v1beta1.MachineInventorySelector{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelector), err
}
