/*
Copyright 2022 SUSE LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/rancher/elemental-operator/pkg/apis/elemental.cattle.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMachineInventorySelectorTemplates implements MachineInventorySelectorTemplateInterface
type FakeMachineInventorySelectorTemplates struct {
	Fake *FakeElementalV1beta1
	ns   string
}

var machineinventoryselectortemplatesResource = schema.GroupVersionResource{Group: "elemental.cattle.io", Version: "v1beta1", Resource: "machineinventoryselectortemplates"}

var machineinventoryselectortemplatesKind = schema.GroupVersionKind{Group: "elemental.cattle.io", Version: "v1beta1", Kind: "MachineInventorySelectorTemplate"}

// Get takes name of the machineInventorySelectorTemplate, and returns the corresponding machineInventorySelectorTemplate object, and an error if there is any.
func (c *FakeMachineInventorySelectorTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.MachineInventorySelectorTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(machineinventoryselectortemplatesResource, c.ns, name), &v1beta1.MachineInventorySelectorTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelectorTemplate), err
}

// List takes label and field selectors, and returns the list of MachineInventorySelectorTemplates that match those selectors.
func (c *FakeMachineInventorySelectorTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.MachineInventorySelectorTemplateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(machineinventoryselectortemplatesResource, machineinventoryselectortemplatesKind, c.ns, opts), &v1beta1.MachineInventorySelectorTemplateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.MachineInventorySelectorTemplateList{ListMeta: obj.(*v1beta1.MachineInventorySelectorTemplateList).ListMeta}
	for _, item := range obj.(*v1beta1.MachineInventorySelectorTemplateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested machineInventorySelectorTemplates.
func (c *FakeMachineInventorySelectorTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(machineinventoryselectortemplatesResource, c.ns, opts))

}

// Create takes the representation of a machineInventorySelectorTemplate and creates it.  Returns the server's representation of the machineInventorySelectorTemplate, and an error, if there is any.
func (c *FakeMachineInventorySelectorTemplates) Create(ctx context.Context, machineInventorySelectorTemplate *v1beta1.MachineInventorySelectorTemplate, opts v1.CreateOptions) (result *v1beta1.MachineInventorySelectorTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(machineinventoryselectortemplatesResource, c.ns, machineInventorySelectorTemplate), &v1beta1.MachineInventorySelectorTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelectorTemplate), err
}

// Update takes the representation of a machineInventorySelectorTemplate and updates it. Returns the server's representation of the machineInventorySelectorTemplate, and an error, if there is any.
func (c *FakeMachineInventorySelectorTemplates) Update(ctx context.Context, machineInventorySelectorTemplate *v1beta1.MachineInventorySelectorTemplate, opts v1.UpdateOptions) (result *v1beta1.MachineInventorySelectorTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(machineinventoryselectortemplatesResource, c.ns, machineInventorySelectorTemplate), &v1beta1.MachineInventorySelectorTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelectorTemplate), err
}

// Delete takes name of the machineInventorySelectorTemplate and deletes it. Returns an error if one occurs.
func (c *FakeMachineInventorySelectorTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(machineinventoryselectortemplatesResource, c.ns, name), &v1beta1.MachineInventorySelectorTemplate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMachineInventorySelectorTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(machineinventoryselectortemplatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.MachineInventorySelectorTemplateList{})
	return err
}

// Patch applies the patch and returns the patched machineInventorySelectorTemplate.
func (c *FakeMachineInventorySelectorTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.MachineInventorySelectorTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(machineinventoryselectortemplatesResource, c.ns, name, pt, data, subresources...), &v1beta1.MachineInventorySelectorTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineInventorySelectorTemplate), err
}
