/*
Copyright 2022 SUSE LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/rancher/elemental-operator/pkg/apis/elemental.cattle.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMachineRegistrations implements MachineRegistrationInterface
type FakeMachineRegistrations struct {
	Fake *FakeElementalV1beta1
	ns   string
}

var machineregistrationsResource = schema.GroupVersionResource{Group: "elemental.cattle.io", Version: "v1beta1", Resource: "machineregistrations"}

var machineregistrationsKind = schema.GroupVersionKind{Group: "elemental.cattle.io", Version: "v1beta1", Kind: "MachineRegistration"}

// Get takes name of the machineRegistration, and returns the corresponding machineRegistration object, and an error if there is any.
func (c *FakeMachineRegistrations) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.MachineRegistration, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(machineregistrationsResource, c.ns, name), &v1beta1.MachineRegistration{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineRegistration), err
}

// List takes label and field selectors, and returns the list of MachineRegistrations that match those selectors.
func (c *FakeMachineRegistrations) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.MachineRegistrationList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(machineregistrationsResource, machineregistrationsKind, c.ns, opts), &v1beta1.MachineRegistrationList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.MachineRegistrationList{ListMeta: obj.(*v1beta1.MachineRegistrationList).ListMeta}
	for _, item := range obj.(*v1beta1.MachineRegistrationList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested machineRegistrations.
func (c *FakeMachineRegistrations) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(machineregistrationsResource, c.ns, opts))

}

// Create takes the representation of a machineRegistration and creates it.  Returns the server's representation of the machineRegistration, and an error, if there is any.
func (c *FakeMachineRegistrations) Create(ctx context.Context, machineRegistration *v1beta1.MachineRegistration, opts v1.CreateOptions) (result *v1beta1.MachineRegistration, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(machineregistrationsResource, c.ns, machineRegistration), &v1beta1.MachineRegistration{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineRegistration), err
}

// Update takes the representation of a machineRegistration and updates it. Returns the server's representation of the machineRegistration, and an error, if there is any.
func (c *FakeMachineRegistrations) Update(ctx context.Context, machineRegistration *v1beta1.MachineRegistration, opts v1.UpdateOptions) (result *v1beta1.MachineRegistration, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(machineregistrationsResource, c.ns, machineRegistration), &v1beta1.MachineRegistration{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineRegistration), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeMachineRegistrations) UpdateStatus(ctx context.Context, machineRegistration *v1beta1.MachineRegistration, opts v1.UpdateOptions) (*v1beta1.MachineRegistration, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(machineregistrationsResource, "status", c.ns, machineRegistration), &v1beta1.MachineRegistration{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineRegistration), err
}

// Delete takes name of the machineRegistration and deletes it. Returns an error if one occurs.
func (c *FakeMachineRegistrations) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(machineregistrationsResource, c.ns, name), &v1beta1.MachineRegistration{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMachineRegistrations) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(machineregistrationsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.MachineRegistrationList{})
	return err
}

// Patch applies the patch and returns the patched machineRegistration.
func (c *FakeMachineRegistrations) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.MachineRegistration, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(machineregistrationsResource, c.ns, name, pt, data, subresources...), &v1beta1.MachineRegistration{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.MachineRegistration), err
}
