/*
Copyright 2022 SUSE LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/rancher/elemental-operator/pkg/apis/elemental.cattle.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeManagedOSImages implements ManagedOSImageInterface
type FakeManagedOSImages struct {
	Fake *FakeElementalV1beta1
	ns   string
}

var managedosimagesResource = schema.GroupVersionResource{Group: "elemental.cattle.io", Version: "v1beta1", Resource: "managedosimages"}

var managedosimagesKind = schema.GroupVersionKind{Group: "elemental.cattle.io", Version: "v1beta1", Kind: "ManagedOSImage"}

// Get takes name of the managedOSImage, and returns the corresponding managedOSImage object, and an error if there is any.
func (c *FakeManagedOSImages) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.ManagedOSImage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(managedosimagesResource, c.ns, name), &v1beta1.ManagedOSImage{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSImage), err
}

// List takes label and field selectors, and returns the list of ManagedOSImages that match those selectors.
func (c *FakeManagedOSImages) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.ManagedOSImageList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(managedosimagesResource, managedosimagesKind, c.ns, opts), &v1beta1.ManagedOSImageList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.ManagedOSImageList{ListMeta: obj.(*v1beta1.ManagedOSImageList).ListMeta}
	for _, item := range obj.(*v1beta1.ManagedOSImageList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested managedOSImages.
func (c *FakeManagedOSImages) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(managedosimagesResource, c.ns, opts))

}

// Create takes the representation of a managedOSImage and creates it.  Returns the server's representation of the managedOSImage, and an error, if there is any.
func (c *FakeManagedOSImages) Create(ctx context.Context, managedOSImage *v1beta1.ManagedOSImage, opts v1.CreateOptions) (result *v1beta1.ManagedOSImage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(managedosimagesResource, c.ns, managedOSImage), &v1beta1.ManagedOSImage{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSImage), err
}

// Update takes the representation of a managedOSImage and updates it. Returns the server's representation of the managedOSImage, and an error, if there is any.
func (c *FakeManagedOSImages) Update(ctx context.Context, managedOSImage *v1beta1.ManagedOSImage, opts v1.UpdateOptions) (result *v1beta1.ManagedOSImage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(managedosimagesResource, c.ns, managedOSImage), &v1beta1.ManagedOSImage{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSImage), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeManagedOSImages) UpdateStatus(ctx context.Context, managedOSImage *v1beta1.ManagedOSImage, opts v1.UpdateOptions) (*v1beta1.ManagedOSImage, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(managedosimagesResource, "status", c.ns, managedOSImage), &v1beta1.ManagedOSImage{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSImage), err
}

// Delete takes name of the managedOSImage and deletes it. Returns an error if one occurs.
func (c *FakeManagedOSImages) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(managedosimagesResource, c.ns, name), &v1beta1.ManagedOSImage{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeManagedOSImages) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(managedosimagesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.ManagedOSImageList{})
	return err
}

// Patch applies the patch and returns the patched managedOSImage.
func (c *FakeManagedOSImages) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ManagedOSImage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(managedosimagesResource, c.ns, name, pt, data, subresources...), &v1beta1.ManagedOSImage{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSImage), err
}
