/*
Copyright 2022 SUSE LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/rancher/elemental-operator/pkg/apis/elemental.cattle.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeManagedOSVersions implements ManagedOSVersionInterface
type FakeManagedOSVersions struct {
	Fake *FakeElementalV1beta1
	ns   string
}

var managedosversionsResource = schema.GroupVersionResource{Group: "elemental.cattle.io", Version: "v1beta1", Resource: "managedosversions"}

var managedosversionsKind = schema.GroupVersionKind{Group: "elemental.cattle.io", Version: "v1beta1", Kind: "ManagedOSVersion"}

// Get takes name of the managedOSVersion, and returns the corresponding managedOSVersion object, and an error if there is any.
func (c *FakeManagedOSVersions) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.ManagedOSVersion, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(managedosversionsResource, c.ns, name), &v1beta1.ManagedOSVersion{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSVersion), err
}

// List takes label and field selectors, and returns the list of ManagedOSVersions that match those selectors.
func (c *FakeManagedOSVersions) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.ManagedOSVersionList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(managedosversionsResource, managedosversionsKind, c.ns, opts), &v1beta1.ManagedOSVersionList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.ManagedOSVersionList{ListMeta: obj.(*v1beta1.ManagedOSVersionList).ListMeta}
	for _, item := range obj.(*v1beta1.ManagedOSVersionList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested managedOSVersions.
func (c *FakeManagedOSVersions) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(managedosversionsResource, c.ns, opts))

}

// Create takes the representation of a managedOSVersion and creates it.  Returns the server's representation of the managedOSVersion, and an error, if there is any.
func (c *FakeManagedOSVersions) Create(ctx context.Context, managedOSVersion *v1beta1.ManagedOSVersion, opts v1.CreateOptions) (result *v1beta1.ManagedOSVersion, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(managedosversionsResource, c.ns, managedOSVersion), &v1beta1.ManagedOSVersion{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSVersion), err
}

// Update takes the representation of a managedOSVersion and updates it. Returns the server's representation of the managedOSVersion, and an error, if there is any.
func (c *FakeManagedOSVersions) Update(ctx context.Context, managedOSVersion *v1beta1.ManagedOSVersion, opts v1.UpdateOptions) (result *v1beta1.ManagedOSVersion, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(managedosversionsResource, c.ns, managedOSVersion), &v1beta1.ManagedOSVersion{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSVersion), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeManagedOSVersions) UpdateStatus(ctx context.Context, managedOSVersion *v1beta1.ManagedOSVersion, opts v1.UpdateOptions) (*v1beta1.ManagedOSVersion, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(managedosversionsResource, "status", c.ns, managedOSVersion), &v1beta1.ManagedOSVersion{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSVersion), err
}

// Delete takes name of the managedOSVersion and deletes it. Returns an error if one occurs.
func (c *FakeManagedOSVersions) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(managedosversionsResource, c.ns, name), &v1beta1.ManagedOSVersion{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeManagedOSVersions) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(managedosversionsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.ManagedOSVersionList{})
	return err
}

// Patch applies the patch and returns the patched managedOSVersion.
func (c *FakeManagedOSVersions) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ManagedOSVersion, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(managedosversionsResource, c.ns, name, pt, data, subresources...), &v1beta1.ManagedOSVersion{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedOSVersion), err
}
